# coding: utf-8

"""
    kameleo-local-api

    You can use the following API endpoints to communicate with the local running Kameleo programmatically.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from kameleo.local_api_client.models.profile_preview import ProfilePreview
from typing import Optional, Set
from typing_extensions import Self

class DeleteFolderResponse(BaseModel):
    """
    DeleteFolderResponse
    """ # noqa: E501
    deleted_folders: Optional[List[StrictStr]] = Field(description="Ids of the deleted folders.", alias="deletedFolders")
    deleted_profiles: Optional[List[StrictStr]] = Field(description="Ids of the deleted profiles.", alias="deletedProfiles")
    moved_profiles: Optional[List[ProfilePreview]] = Field(description="Ids of the profiles moved to top-level.", alias="movedProfiles")
    __properties: ClassVar[List[str]] = ["deletedFolders", "deletedProfiles", "movedProfiles"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeleteFolderResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in moved_profiles (list)
        _items = []
        if self.moved_profiles:
            for _item_moved_profiles in self.moved_profiles:
                if _item_moved_profiles:
                    _items.append(_item_moved_profiles.to_dict())
            _dict['movedProfiles'] = _items
        # set to None if deleted_folders (nullable) is None
        # and model_fields_set contains the field
        if self.deleted_folders is None and "deleted_folders" in self.model_fields_set:
            _dict['deletedFolders'] = None

        # set to None if deleted_profiles (nullable) is None
        # and model_fields_set contains the field
        if self.deleted_profiles is None and "deleted_profiles" in self.model_fields_set:
            _dict['deletedProfiles'] = None

        # set to None if moved_profiles (nullable) is None
        # and model_fields_set contains the field
        if self.moved_profiles is None and "moved_profiles" in self.model_fields_set:
            _dict['movedProfiles'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeleteFolderResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "deletedFolders": obj.get("deletedFolders"),
            "deletedProfiles": obj.get("deletedProfiles"),
            "movedProfiles": [ProfilePreview.from_dict(_item) for _item in obj["movedProfiles"]] if obj.get("movedProfiles") is not None else None
        })
        return _obj


